#include<iostream>
#include<cmath>
using namespace std;
int main(){
	long long T,N,M,A[3000],B[3000],p,br=0,min;
	cin>>T;
	for(int i=0;i<T;i++){
		p=1;
		cin>>N;
		cin>>M;
		for(int j=0;j<N;j++)cin>>A[j];
		min=abs(A[0]-A[1]);
		for(int q=0;q<M;q++)cin>>B[q];
		for(int j=0;j<N-1;j++){
			for(int l=j+1;l<N;l++){
				if((long long)abs(A[j]-A[l])<min)min=abs(A[j]-A[l]);
			}
		}
		for(int j=0;j<N-1;j++){
			for(int l=j+1;l<N;l++){
				if((long long)abs(A[j]-A[l])%min!=0)p=0;break;
			}
		}
		for(int a=0;a<M-1;a++){
			for(int b=a+1;b<M;b++){
				if((long long)abs(B[a]-B[b])%min!=0)br=1;
			}
			if(br==0)p=0;
		}
		br=0;
		if(p==1)cout<<"1"<<endl;
		else cout<<"0"<<endl;
	}
	return 0;
}